
/*******************
 * From src: nachos/src/js/nachos.js
 *******************/
var export_in_progress = false;
$(document).ready(function() {
    var pathname = window.location.search;
    var pathnameArray = pathname.split('=', pathname.length);
    var pathnameArrayIncludes = pathnameArray.indexOf('export.php');

    if (pathnameArrayIncludes == -1) {
        return;
    }

    var latest_export_id = null;
    if($('div#nachos-page-banners').length == 0) {
        $('div.content').prepend('<div id="nachos-page-banners" class="notify-notification-bar"></div>');
    }
    $.ajax({
        url : '/monitor/index.php/nachos/users_latest_export',
        type : 'GET',
        success : function(latest_export_id) {
            var css_id = 'nachos_css';
            if (!document.getElementById(css_id)) {
                var head  = document.getElementsByTagName('head')[0];
                var link  = document.createElement('link');
                link.id   = css_id;
                link.rel  = 'stylesheet';
                link.type = 'text/css';
                link.href = '/monitor/modules/nachos/media/css/nachos.css';
                link.media = 'all';
                head.appendChild(link);
            }
            var div = $('div#nachos-page-banners');
            update_data(div, 'banner_content', true, latest_export_id);
        }
    });

    $(document).on('click', '.view-export-details', function(e) {
        var export_id = $(this).data('exportid');
        var lightbox = LightboxManager.create();
        var title = document.createElement('h1');
        title.textContent = 'Changes could not be saved';
        lightbox.header(title);

        var cancel = document.createElement('input');
        cancel.setAttribute('type', 'button');
        cancel.setAttribute('name', 'close');
        cancel.setAttribute('value', 'Close');
        cancel.setAttribute('class', 'export-close-button');
        lightbox.footer(cancel);

        var fragment = document.createElement('div');
        fragment.innerHTML = '<img ' +
                'src="/ninja/application/media/images/rolling-1s-200px.gif" ' +
                'title="Loading..." width="40" height="40" />';
        lightbox.content(fragment);
        lightbox.show();
        update_data(fragment, 'details', null, export_id);

        $(document).on('click', '.lightbox-footer input.export-close-button', function(e){
            fragment.value = false;
            lightbox.hide();
        });

        e.preventDefault();
        return false;
    });

    $(document).on('click', 'div.close-nachos-banner', function(e) {
        var banner_id = this.id.replace("close-nachos-banner-", "");
        close_nachos_banner(banner_id);
    });

    $("iframe.save_config_nac_iframe").load(function(){
        var save_button = $(this).contents().find("input[name*='nachos_save_btn']");
        if (save_button) {
            save_button.each(function() {
                if($(this).is(":disabled")) {
                    $(this).css('cursor', 'default');
                }
            });
            save_button.on("click", function(){
                var id_parts = this.id.split('_');
                var export_type = id_parts[id_parts.length - 1];
                start_export(export_type);
            });
        }
    });

    $(window).unload(function() {
        close_previous_banners(true);
    });
});

function update_data(container, url, is_div, export_id) {
    var dont_print = false;
    var is_config = $('div.main-toolbar-title').text() === "Configuration";
    if($('div.container div#header.header div#profile.profile.menu').length == 0) {
        return false;
    }
    if((is_div === true && container.length == 0) || container.value == false) {
        return false;
    }
    if(export_id != null && export_id != false && export_id != "" && export_id != "undefined") {
        if(localStorage.getItem('nachos-banner-closed-' + export_id) == "true") {
            dont_print = true;
        }
    }
    var parameters =  { 'is_config' : is_config };
    if(url == 'details' && (export_id != null && export_id != false && export_id != "" && export_id != "undefined")) {
        parameters.export_id = export_id;
    }

    if(!document.hidden) {
        $.ajax({
            url : '/monitor/index.php/nachos/' + url,
            type : 'GET',
            data : parameters,
            success : function(data) {
                if(dont_print === false) {
                    if(is_div === true) {
                        container.html(data);
                    } else {
                        container.innerHTML = data;
                    }
                }
            }
        });
        check_export_in_progress();
    }

    setTimeout(function() {
        update_data(container, url, is_div, export_id);
    }, 4000);
}

function check_export_in_progress() {
    $.ajax({
        url : '/api/nachos/v1/latestexport?auth_method=ninja',
        type : 'GET',
        async: true,
        success : function(data) {
            if (data['status'] === 'running' || data['status'] === 'pending') {
                set_export_in_progress(true);
            } else if(data['status'] === 'success' && export_in_progress === true) {
                set_export_in_progress(false);
                if($("iframe.save_config_nac_iframe").contents().get(0) != undefined) {
                    $("iframe.save_config_nac_iframe").contents().get(0).location.href = $("iframe.save_config_nac_iframe").contents().get(0).location.href;
                }
            }
        }
    });
}

function start_export(type) {
    set_export_in_progress(true);
    $.get( '/monitor/index.php/nachos/username', function(username) {
        $.ajax({
            url : '/api/nachos/v1/exports?auth_method=ninja',
            type : 'POST',
            contentType: 'application/json',
            data : '{"user":"' + username + '","export_type":"' + type + '_export"}',
            timeout: 6000,
            success : function(data) {
                var div = $('div#nachos-page-banners');
                update_data(div, 'banner_content', true, data['id']);
                close_previous_banners();
            },
            error : function(request, textStatus, errorThrown) {
                set_export_in_progress(false);
            }
        });
    });
    return true;
}

function set_export_in_progress(new_progress) {

    if (new_progress == export_in_progress) {
        return false;
    }

    export_in_progress = new_progress;

    var nachos_iframe = $("iframe.save_config_nac_iframe");
    var save_button = nachos_iframe.contents().find("input[name*='nachos_save_btn']");

    if (new_progress) {
        save_button.attr('disabled', 'disabled');
        nachos_iframe.contents().find("div.nachos_save_page").css({
            '-webkit-user-select': 'none',
            '-moz-user-select': 'none',
            '-ms-user-select': 'none',
            'user-select': 'none',
            'color': '#999',
            'pointer-events': 'none',
            'cursor': 'default'
        });
        nachos_iframe.contents().find("h2").css('color', '#999');

        nachos_iframe.contents().find("a").each(function(){
            var link_text = $(this).text();
            $(this).before(link_text);
            $(this).remove();
        });
    } else {
        save_button.removeAttr('disabled');
        nachos_iframe.contents().find("div.nachos_save_page").css({
            '-webkit-user-select': 'auto',
            '-moz-user-select': 'auto',
            '-ms-user-select': 'auto',
            'user-select': 'auto',
            'color': '#3a3a3a',
            'pointer-events': 'auto',
            'cursor': 'pointer'
        });
        nachos_iframe.contents().find("h2").css('color', '#000');
    }
    return true;
}

function close_nachos_banner(banner_id) {
    $('div#nachos-export-banner-id-' + banner_id).remove();
    localStorage.setItem('nachos-banner-closed-' + banner_id, 'true');
}

function close_previous_banners(only_success) {
    $('div.nachos-banner-wrapper').each(function(index) {
        var banner_status = $(this).data('status');
        if(only_success == true){
            if(banner_status == 'success') {
                var banner_id = this.id.replace("nachos-export-banner-id-", "");
                close_nachos_banner(banner_id);
            }
        } else {
            if(banner_status == 'success' || banner_status == 'fail') {
                var banner_id = this.id.replace("nachos-export-banner-id-", "");
                close_nachos_banner(banner_id);
            }
        }
    });
}


